[coreboot] [commit] r5568 - in trunk/util/crossgcc: . patches

repository service svn at coreboot.org
Mon May 17 13:02:25 CEST 2010


Author: stepan
Date: Mon May 17 13:02:25 2010
New Revision: 5568
URL: https://tracker.coreboot.org/trac/coreboot/changeset/5568

Log:
New buildgcc version.

Signed-off-by: Stefan Reinauer <stepan at coresystems.de>
Acked-by: Patrick Georgi <patrick.georgi at coresystems.de>

Added:
   trunk/util/crossgcc/patches/mpfr-2.4.2_allpatches_20100308.patch
Modified:
   trunk/util/crossgcc/buildgcc

Modified: trunk/util/crossgcc/buildgcc
==============================================================================
--- trunk/util/crossgcc/buildgcc	Mon May 17 12:21:10 2010	(r5567)
+++ trunk/util/crossgcc/buildgcc	Mon May 17 13:02:25 2010	(r5568)
@@ -1,6 +1,6 @@
 #!/bin/bash
 #
-# Copyright (C) 2008-2009 by coresystems GmbH
+# Copyright (C) 2008-2010 by coresystems GmbH
 # written by Patrick Georgi <patrick.georgi at coresystems.de> and
 #            Stefan Reinauer <stefan.reinauer at coresystems.de>
 #
@@ -18,8 +18,8 @@
 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 #
 
-CROSSGCC_DATE="August 18th, 2009"
-CROSSGCC_VERSION="0.9"
+CROSSGCC_DATE="March 29th, 2010"
+CROSSGCC_VERSION="1.0"
 
 # default settings
 TARGETDIR=`pwd`/xgcc
@@ -27,17 +27,21 @@
 DESTDIR=
 
 # version numbers
-GMP_VERSION=4.3.1
+GMP_VERSION=5.0.1
 MPFR_VERSION=2.4.2
-GCC_VERSION=4.4.2
-BINUTILS_VERSION=2.20
-GDB_VERSION=7.0
+MPC_VERSION=0.8.2
+LIBELF_VERSION=0.8.13
+GCC_VERSION=4.5.0 # enable for Link Time Optimization & Co
+BINUTILS_VERSION=2.20.1
+GDB_VERSION=7.1
 W32API_VERSION=3.14
 MINGWRT_VERSION=3.18
 
 # archive locations
 GMP_ARCHIVE="ftp://ftp.gmplib.org/pub/gmp-${GMP_VERSION}/gmp-${GMP_VERSION}.tar.bz2"
 MPFR_ARCHIVE="http://www.mpfr.org/mpfr-${MPFR_VERSION}/mpfr-${MPFR_VERSION}.tar.bz2"
+MPC_ARCHIVE="http://www.multiprecision.org/mpc/download/mpc-${MPC_VERSION}.tar.gz"
+LIBELF_ARCHIVE="http://www.mr511.de/software/libelf-${LIBELF_VERSION}.tar.gz"
 GCC_ARCHIVE="ftp://ftp.gwdg.de/pub/gnu/ftp/gnu/gcc/gcc-${GCC_VERSION}/gcc-core-${GCC_VERSION}.tar.bz2"
 BINUTILS_ARCHIVE="http://ftp.gnu.org/gnu/binutils/binutils-${BINUTILS_VERSION}.tar.bz2"
 GDB_ARCHIVE="http://ftp.gnu.org/gnu/gdb/gdb-${GDB_VERSION}.tar.bz2"
@@ -46,6 +50,8 @@
 
 GMP_DIR="gmp-${GMP_VERSION}"
 MPFR_DIR="mpfr-${MPFR_VERSION}"
+MPC_DIR="mpc-${MPC_VERSION}"
+LIBELF_DIR="libelf-${LIBELF_VERSION}"
 GCC_DIR="gcc-${GCC_VERSION}"
 BINUTILS_DIR="binutils-${BINUTILS_VERSION}"
 GDB_DIR="gdb-${GDB_VERSION}"
@@ -88,7 +94,7 @@
 cleanup()
 {
 	printf "Cleaning up temporary files... "
-	rm -rf build-* combined gcc-* gmp-* mpfr-* binutils-* gdb-* w32api-* mingwrt-*
+	rm -rf build-* combined gcc-* gmp-* mpfr-* mpc-* libelf-* binutils-* gdb-* w32api-* mingwrt-*
 	printf "${green}ok${NC}\n"
 }
 
@@ -117,7 +123,7 @@
 	# version tag is always printed, so just print the license here
 
 	cat << EOF
-Copyright (C) 2008-2009 by coresystems GmbH
+Copyright (C) 2008-2010 by coresystems GmbH
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
@@ -175,9 +181,33 @@
 	MINGW_ARCHIVES="$W32API_ARCHIVE $MINGWRT_ARCHIVE"
 fi
 
+if [ ${GCC_VERSION} == "4.5.0" -o ${GCC_VERSION} == "4.6.0" ]; then
+  # coreboot does not like the GOLD linker
+  # USE_GOLD="--enable-gold"
+  USE_GOLD=""
+  GCC_OPTIONS="--enable-lto"
+fi
+
+if [ ${GCC_VERSION} == "4.6.0" ]; then
+  if [ ! -r tarballs/gcc-core-${GCC_VERSION}.tar.bz2 ]; then
+    printf "Pre-Release GCC ${GCC_VERSION}, checking out subversion trunk\n"
+    mkdir -p tarballs/.tmp
+    cd tarballs/.tmp
+    rm -rf gcc-${GCC_VERSION}
+    svn export -q svn://gcc.gnu.org/svn/gcc/trunk gcc-${GCC_VERSION}
+    printf "done. Now creating tar ball...\n"
+    tar cjf ../gcc-core-${GCC_VERSION}.tar.bz2 gcc-${GCC_VERSION}
+    printf "done. Now cleaning up...\n"
+    cd ..
+    rm -rf .tmp
+    cd ..
+    printf "done.\n"
+  fi
+fi
+
 printf "Downloading tar balls ... \n"
 mkdir -p tarballs
-for ARCHIVE in $GMP_ARCHIVE $MPFR_ARCHIVE $GCC_ARCHIVE $BINUTILS_ARCHIVE $GDB_ARCHIVE $MINGW_ARCHIVES; do
+for ARCHIVE in $GMP_ARCHIVE $MPFR_ARCHIVE $MPC_ARCHIVE $LIBELF_ARCHIVE $GCC_ARCHIVE $BINUTILS_ARCHIVE $GDB_ARCHIVE $MINGW_ARCHIVES; do
 	FILE=`basename $ARCHIVE`
 	printf " * $FILE "
 	test -f tarballs/$FILE && printf "(cached)" || (
@@ -185,7 +215,7 @@
 		cd tarballs
 		wget -q $ARCHIVE
 	)
-	test -f tarballs/$FILE || printf "Failed to download $FILE.\n"
+	test -f tarballs/$FILE || printf "\n${RED}Failed to download $FILE.${red}\n"
 	test -f tarballs/$FILE || exit 1
 	printf "\n"
 done
@@ -198,7 +228,7 @@
 fi
 
 printf "Unpacking and patching ... \n"
-for PACKAGE in GMP MPFR GCC BINUTILS GDB $MINGW_PACKAGES; do
+for PACKAGE in GMP MPFR MPC LIBELF GCC BINUTILS GDB $MINGW_PACKAGES; do
 	archive=$PACKAGE"_ARCHIVE"
 	archive=${!archive}
 	dir=$PACKAGE"_DIR"
@@ -223,7 +253,29 @@
 	mv $MINGWRT_DIR/include/* $W32API_DIR/include/* $TARGETDIR/i386-mingw32/sys-include
 fi
 
-mkdir -p build-gmp build-mpfr build-binutils build-gcc build-gdb
+if [ `uname` = "Darwin" ]; then
+	#GCC_OPTIONS="$GCC_OPTIONS --enable-threads=posix"
+
+	# generally the OS X compiler can create x64 binaries.
+	# Per default it generated i386 binaries in 10.5 and x64
+	# binaries in 10.6 (even if the kernel is 32bit)
+	# For some weird reason, 10.5 autodetects an ABI=64 though
+	# so we're setting the ABI explicitly here.
+	if [ `sysctl -n hw.optional.x86_64` -eq 1 ]; then
+		OPTIONS="ABI=64"
+	else
+		OPTIONS="ABI=32"
+	fi
+	# old check:
+	#OPTIONS="ABI=32"
+	#touch .architecture_check.c
+	#gcc .architecture_check.c -c -o .architecture_check.o
+	#ARCH=`file .architecture_check.o |cut -f5 -d\ `
+	#test  "$ARCH" = "x86_64" && OPTIONS="ABI=64"
+	#rm .architecture_check.c .architecture_check.o
+fi
+
+mkdir -p build-gmp build-mpfr build-mpc build-libelf build-binutils build-gcc build-gdb
 if [ -f build-gmp/.success ]; then
 	printf "Skipping GMP as it is already built\n"
 else
@@ -231,20 +283,6 @@
 (
 	cd build-gmp
 	rm -f .failed
-	if [ `uname` = "Darwin" ]; then
-		# generally the OS X compiler can create x64 binaries.
-		# Per default it generated i386 binaries in 10.5 and x64
-		# binaries in 10.6 (even if the kernel is 32bit)
-		# For some weird reason, 10.5 autodetects an ABI=64 though
-		# so we're setting the ABI explicitly here.
-		OPTIONS="ABI=32"
-		touch .architecture_check.c
-		gcc .architecture_check.c -c -o .architecture_check.o
-		ARCH=`file .architecture_check.o |cut -f5 -d\ `
-		test  "$ARCH" = "x86_64" && OPTIONS="ABI=64"
-		rm .architecture_check.c .architecture_check.o
-	fi
-
 	../${GMP_DIR}/configure --disable-shared --prefix=$TARGETDIR $OPTIONS \
 		|| touch .failed
 	$MAKE $JOBS || touch .failed
@@ -288,15 +326,57 @@
 test -r build-mpfr/.failed && exit 1
 fi
 
+if [ -f build-mpc/.success ]; then
+	printf "Skipping MPC as it is already built\n"
+else
+printf "Building MPC ${MPC_VERSION} ... "
+(
+	#test `uname` = "Darwin" && CFLAGS="$CFLAGS -force_cpusubtype_ALL"
+	cd build-mpc
+	rm -f .failed
+	../${MPC_DIR}/configure --disable-shared --prefix=$TARGETDIR \
+		--infodir=$TARGETDIR/info --with-mpfr=$DESTDIR$TARGETDIR \
+		--with-gmp=$DESTDIR$TARGETDIR CFLAGS="$HOSTCFLAGS" || touch .failed
+	$MAKE $JOBS || touch .failed
+	$MAKE install DESTDIR=$DESTDIR || touch .failed
+
+	if [ ! -f .failed ]; then touch .success; fi
+) &> build-mpc/crossgcc-build.log
+test -r build-mpc/.failed && printf "${RED}failed${NC}\n" || printf "${green}ok${NC}\n"
+test -r build-mpc/.failed && exit 1
+fi
+
+if [ -f build-libelf/.success ]; then
+	printf "Skipping libelf as it is already built\n"
+else
+printf "Building libelf ${LIBELF_VERSION} ... "
+(
+	cd build-libelf
+	rm -f .failed
+	echo "$HOSTCFLAGS"
+	CFLAGS="$HOSTCFLAGS"  ../${LIBELF_DIR}/configure --disable-shared --prefix=$TARGETDIR \
+		--infodir=$TARGETDIR/info CFLAGS="$HOSTCFLAGS" || touch .failed
+	$MAKE $JOBS || touch .failed
+	$MAKE install DESTDIR=$DESTDIR || touch .failed
+
+	if [ ! -f .failed ]; then touch .success; fi
+) &> build-libelf/crossgcc-build.log
+test -r build-libelf/.failed && printf "${RED}failed${NC}\n" || printf "${green}ok${NC}\n"
+test -r build-libelf/.failed && exit 1
+fi
+
 if [ -f build-binutils/.success ]; then
 	printf "Skipping binutils as it is already built\n"
 else
 printf "Building binutils ${BINUTILS_VERSION} ... "
 (
+	# workaround for building binutils 2.20.1 on MINGW:
+ 	touch ../binutils-${BINUTILS_VERSION}/bfd/doc/bfd.info
+	# now build binutils
 	cd build-binutils
 	rm -f .failed
 	../binutils-${BINUTILS_VERSION}/configure --prefix=$TARGETDIR --target=${TARGETARCH} \
-		--disable-werror --disable-nls \
+		--disable-werror --disable-nls $USE_GOLD \
 		CFLAGS="$HOSTCFLAGS" || touch .failed
 	$MAKE $JOBS || touch .failed
 	$MAKE install DESTDIR=$DESTDIR || touch .failed
@@ -318,11 +398,14 @@
 	# There's a work-around called CFLAGS_FOR_BUILD and CFLAGS_FOR_TARGET
 	# but it does not seem to work properly. At least the host library
 	# libiberty is not compiled with CFLAGS_FOR_BUILD.
-	CFLAGS_FOR_BUILD="$HOSTCFLAGS" ../gcc-${GCC_VERSION}/configure \
+	CFLAGS_FOR_TARGET="-O2" CFLAGS="$HOSTCFLAGS" CFLAGS_FOR_BUILD="$HOSTCFLAGS" ../gcc-${GCC_VERSION}/configure \
 		--prefix=$TARGETDIR --libexecdir=$TARGETDIR/lib \
 		--target=${TARGETARCH} --disable-werror --disable-shared \
 		--disable-libssp --disable-bootstrap --disable-nls \
+		$GCC_OPTIONS --enable-languages="c" $USE_GOLD \
 		--with-gmp=$DESTDIR$TARGETDIR --with-mpfr=$DESTDIR$TARGETDIR \
+		--with-mpc=$DESTDIR$TARGETDIR --with-libelf=$DESTDIR$TARGETDIR \
+		--with-pkgversion="coreboot toolchain v$CROSSGCC_VERSION $CROSSGCC_DATE" \
 		|| touch .failed
 	$MAKE $JOBS CFLAGS_FOR_BUILD="$HOSTCFLAGS" || touch .failed
 	$MAKE install DESTDIR=$DESTDIR || touch .failed
@@ -340,8 +423,8 @@
 	cd build-gdb
 	export PATH=$PATH:$PREFIX/bin
 	rm -f .failed
-	../gdb-${GDB_VERSION}/configure --prefix=$TARGETDIR --target=${TARGETARCH} \
-		--disable-werror --disable-nls
+	CFLAGS="$HOSTCFLAGS" ../gdb-${GDB_VERSION}/configure --prefix=$TARGETDIR --target=${TARGETARCH} \
+		--without-python --disable-werror --disable-nls
 	$MAKE $JOBS || touch .failed
 	$MAKE install DESTDIR=$DESTDIR || touch .failed
 	if [ ! -f .failed ]; then touch .success; fi
@@ -354,6 +437,8 @@
 	printf "Cleaning up... "
 	rm -rf ${GMP_DIR} build-gmp
 	rm -rf ${MPFR_DIR} build-mpfr
+	rm -rf ${MPC_DIR} build-mpc
+	rm -rf ${LIBELF_DIR} build-libelf
 	rm -rf ${BINUTILS_DIR} build-binutils
 	rm -rf ${GCC_DIR} build-gcc
 	rm -rf ${GDB_DIR} build-gdb

Added: trunk/util/crossgcc/patches/mpfr-2.4.2_allpatches_20100308.patch
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ trunk/util/crossgcc/patches/mpfr-2.4.2_allpatches_20100308.patch	Mon May 17 13:02:25 2010	(r5568)
@@ -0,0 +1,266 @@
+diff -ur mpfr-2.4.2.orig/PATCHES mpfr-2.4.2/PATCHES
+--- mpfr-2.4.2.orig/PATCHES	2010-03-08 22:28:46.000000000 +0100
++++ mpfr-2.4.2/PATCHES	2010-03-08 22:28:53.000000000 +0100
+@@ -0,0 +1,3 @@
++gmp5
++longlong.h
++sin_cos_underflow
+diff -ur mpfr-2.4.2.orig/VERSION mpfr-2.4.2/VERSION
+--- mpfr-2.4.2.orig/VERSION	2010-03-08 22:28:46.000000000 +0100
++++ mpfr-2.4.2/VERSION	2010-03-08 22:28:53.000000000 +0100
+@@ -1 +1 @@
+-2.4.2
++2.4.2-p3
+diff -ur mpfr-2.4.2.orig/configure mpfr-2.4.2/configure
+--- mpfr-2.4.2.orig/configure	2010-03-08 22:28:46.000000000 +0100
++++ mpfr-2.4.2/configure	2010-03-08 22:28:53.000000000 +0100
+@@ -20449,6 +20449,9 @@
+ main ()
+ {
+ 
++#ifndef BITS_PER_MP_LIMB
++#define BITS_PER_MP_LIMB GMP_LIMB_BITS
++#endif
+   return BITS_PER_MP_LIMB == BYTES_PER_MP_LIMB * CHAR_BIT
+          && sizeof(mp_limb_t) == BYTES_PER_MP_LIMB ? 0 : 1;
+ 
+diff -ur mpfr-2.4.2.orig/configure.in mpfr-2.4.2/configure.in
+--- mpfr-2.4.2.orig/configure.in	2010-03-08 22:28:46.000000000 +0100
++++ mpfr-2.4.2/configure.in	2010-03-08 22:28:53.000000000 +0100
+@@ -424,6 +424,9 @@
+ #include "gmp.h"
+ #include "gmp-impl.h"
+ ]], [[
++#ifndef BITS_PER_MP_LIMB
++#define BITS_PER_MP_LIMB GMP_LIMB_BITS
++#endif
+   return BITS_PER_MP_LIMB == BYTES_PER_MP_LIMB * CHAR_BIT
+          && sizeof(mp_limb_t) == BYTES_PER_MP_LIMB ? 0 : 1;
+ ]])], [AC_MSG_RESULT(yes)], [
+diff -ur mpfr-2.4.2.orig/mpfr-impl.h mpfr-2.4.2/mpfr-impl.h
+--- mpfr-2.4.2.orig/mpfr-impl.h	2010-03-08 22:28:46.000000000 +0100
++++ mpfr-2.4.2/mpfr-impl.h	2010-03-08 22:28:53.000000000 +0100
+@@ -65,6 +65,12 @@
+ # ifndef __GMP_IMPL_H__
+ #  include "gmp-impl.h"
+ # endif
++# ifndef BITS_PER_MP_LIMB
++#  define BITS_PER_MP_LIMB GMP_LIMB_BITS
++# endif
++#ifndef mpn_sqr_n
++# define mpn_sqr_n mpn_sqr
++#endif
+ # ifdef MPFR_NEED_LONGLONG_H
+ #  include "longlong.h"
+ # endif
+diff -ur mpfr-2.4.2.orig/mpfr-longlong.h mpfr-2.4.2/mpfr-longlong.h
+--- mpfr-2.4.2.orig/mpfr-longlong.h	2010-03-08 22:28:46.000000000 +0100
++++ mpfr-2.4.2/mpfr-longlong.h	2010-03-08 22:28:53.000000000 +0100
+@@ -1011,7 +1011,15 @@
+ #endif /* __m88000__ */
+ 
+ #if defined (__mips) && W_TYPE_SIZE == 32
+-#if __GNUC__ > 2 || __GNUC_MINOR__ >= 7
++#if (__GNUC__ >= 5) || (__GNUC__ >= 4 && __GNUC_MINOR__ >= 4)
++#define umul_ppmm(w1, w0, u, v) \
++  do {									\
++    UDItype _r;							\
++    _r = (UDItype) u * v;						\
++    (w1) = _r >> 32;							\
++    (w0) = (USItype) _r;						\
++  } while (0)
++#elif __GNUC__ > 2 || __GNUC_MINOR__ >= 7
+ #define umul_ppmm(w1, w0, u, v) \
+   __asm__ ("multu %2,%3" : "=l" (w0), "=h" (w1) : "d" (u), "d" (v))
+ #else
+@@ -1024,7 +1032,16 @@
+ #endif /* __mips */
+ 
+ #if (defined (__mips) && __mips >= 3) && W_TYPE_SIZE == 64
+-#if __GNUC__ > 2 || __GNUC_MINOR__ >= 7
++#if (__GNUC__ >= 5) || (__GNUC__ >= 4 && __GNUC_MINOR__ >= 4)
++typedef unsigned int UTItype __attribute__ ((mode (TI)));
++#define umul_ppmm(w1, w0, u, v) \
++  do {									\
++    UTItype _r;							\
++    _r = (UTItype) u * v;						\
++    (w1) = _r >> 64;							\
++    (w0) = (UDItype) _r;						\
++  } while (0)
++#elif __GNUC__ > 2 || __GNUC_MINOR__ >= 7
+ #define umul_ppmm(w1, w0, u, v) \
+   __asm__ ("dmultu %2,%3" : "=l" (w0), "=h" (w1) : "d" (u), "d" (v))
+ #else
+diff -ur mpfr-2.4.2.orig/mpfr.h mpfr-2.4.2/mpfr.h
+--- mpfr-2.4.2.orig/mpfr.h	2010-03-08 22:28:46.000000000 +0100
++++ mpfr-2.4.2/mpfr.h	2010-03-08 22:28:53.000000000 +0100
+@@ -27,7 +27,7 @@
+ #define MPFR_VERSION_MAJOR 2
+ #define MPFR_VERSION_MINOR 4
+ #define MPFR_VERSION_PATCHLEVEL 2
+-#define MPFR_VERSION_STRING "2.4.2"
++#define MPFR_VERSION_STRING "2.4.2-p3"
+ 
+ /* Macros dealing with MPFR VERSION */
+ #define MPFR_VERSION_NUM(a,b,c) (((a) << 16L) | ((b) << 8) | (c))
+diff -ur mpfr-2.4.2.orig/sin_cos.c mpfr-2.4.2/sin_cos.c
+--- mpfr-2.4.2.orig/sin_cos.c	2010-03-08 22:28:46.000000000 +0100
++++ mpfr-2.4.2/sin_cos.c	2010-03-08 22:28:53.000000000 +0100
+@@ -82,17 +82,19 @@
+       if (y != x)
+         /* y and x differ, thus we can safely try to compute y first */
+         {
+-          MPFR_FAST_COMPUTE_IF_SMALL_INPUT (y, x, -2 * expx, 2, 0, rnd_mode,
+-                                            { inexy = _inexact;
+-                                              goto small_input; });
++          MPFR_FAST_COMPUTE_IF_SMALL_INPUT (
++            y, x, -2 * expx, 2, 0, rnd_mode,
++            { inexy = _inexact;
++              goto small_input; });
+           if (0)
+             {
+             small_input:
+               /* we can go here only if we can round sin(x) */
+-              MPFR_FAST_COMPUTE_IF_SMALL_INPUT (z, __gmpfr_one, -2 * expx,
+-                                                1, 0, rnd_mode,
+-                                                { inexz = _inexact;
+-                                                  goto end; });
++              MPFR_FAST_COMPUTE_IF_SMALL_INPUT (
++                z, __gmpfr_one, -2 * expx, 1, 0, rnd_mode,
++                { inexz = _inexact;
++                  MPFR_SAVE_EXPO_UPDATE_FLAGS (expo, __gmpfr_flags);
++                  goto end; });
+             }
+ 
+           /* if we go here, one of the two MPFR_FAST_COMPUTE_IF_SMALL_INPUT
+@@ -101,18 +103,19 @@
+       else /* y and x are the same variable: try to compute z first, which
+               necessarily differs */
+         {
+-          MPFR_FAST_COMPUTE_IF_SMALL_INPUT (z, __gmpfr_one, -2 * expx,
+-                                            1, 0, rnd_mode,
+-                                            { inexz = _inexact;
+-                                              goto small_input2; });
++          MPFR_FAST_COMPUTE_IF_SMALL_INPUT (
++            z, __gmpfr_one, -2 * expx, 1, 0, rnd_mode,
++            { inexz = _inexact;
++              goto small_input2; });
+           if (0)
+             {
+             small_input2:
+               /* we can go here only if we can round cos(x) */
+-              MPFR_FAST_COMPUTE_IF_SMALL_INPUT (y, x, -2 * expx, 2, 0,
+-                                                rnd_mode,
+-                                                { inexy = _inexact;
+-                                                  goto end; });
++              MPFR_FAST_COMPUTE_IF_SMALL_INPUT (
++                y, x, -2 * expx, 2, 0, rnd_mode,
++                { inexy = _inexact;
++                  MPFR_SAVE_EXPO_UPDATE_FLAGS (expo, __gmpfr_flags);
++                  goto end; });
+             }
+         }
+       m += 2 * (-expx);
+@@ -207,7 +210,6 @@
+   mpfr_clear (xr);
+ 
+  end:
+-  /* FIXME: update the underflow flag if need be. */
+   MPFR_SAVE_EXPO_FREE (expo);
+   mpfr_check_range (y, inexy, rnd_mode);
+   mpfr_check_range (z, inexz, rnd_mode);
+diff -ur mpfr-2.4.2.orig/tests/tsin_cos.c mpfr-2.4.2/tests/tsin_cos.c
+--- mpfr-2.4.2.orig/tests/tsin_cos.c	2010-03-08 22:28:46.000000000 +0100
++++ mpfr-2.4.2/tests/tsin_cos.c	2010-03-08 22:28:53.000000000 +0100
+@@ -382,23 +382,56 @@
+ consistency (void)
+ {
+   mpfr_t x, s1, s2, c1, c2;
++  mp_exp_t emin, emax;
+   mp_rnd_t rnd;
++  unsigned int flags_sin, flags_cos, flags, flags_before, flags_ref;
++  int inex_sin, inex_cos, inex, inex_ref;
+   int i;
+ 
++  emin = mpfr_get_emin ();
++  emax = mpfr_get_emax ();
++
+   for (i = 0; i <= 10000; i++)
+     {
+       mpfr_init2 (x, MPFR_PREC_MIN + (randlimb () % 8));
+       mpfr_inits2 (MPFR_PREC_MIN + (randlimb () % 8), s1, s2, c1, c2,
+                    (mpfr_ptr) 0);
+-      tests_default_random (x, 256, -5, 50);
+-      rnd = RND_RAND ();
+-      mpfr_sin (s1, x, rnd);
+-      mpfr_cos (c1, x, rnd);
+-      mpfr_sin_cos (s2, c2, x, rnd);
+-      if (!(mpfr_equal_p (s1, s2) && mpfr_equal_p (c1, c2)))
++      if (i < 8 * GMP_RND_MAX)
++        {
++          int j = i / GMP_RND_MAX;
++          if (j & 1)
++            mpfr_set_emin (MPFR_EMIN_MIN);
++          mpfr_set_si (x, (j & 2) ? 1 : -1, GMP_RNDN);
++          mpfr_set_exp (x, mpfr_get_emin ());
++          rnd = (mpfr_rnd_t) (i % GMP_RND_MAX);
++          flags_before = 0;
++          if (j & 4)
++            mpfr_set_emax (-17);
++        }
++      else
++        {
++          tests_default_random (x, 256, -5, 50);
++          rnd = RND_RAND ();
++          flags_before = (randlimb () & 1) ?
++            (unsigned int) (MPFR_FLAGS_ALL ^ MPFR_FLAGS_ERANGE) :
++            (unsigned int) 0;
++        }
++      __gmpfr_flags = flags_before;
++      inex_sin = mpfr_sin (s1, x, rnd);
++      flags_sin = __gmpfr_flags;
++      __gmpfr_flags = flags_before;
++      inex_cos = mpfr_cos (c1, x, rnd);
++      flags_cos = __gmpfr_flags;
++      __gmpfr_flags = flags_before;
++      inex = !!mpfr_sin_cos (s2, c2, x, rnd);
++      flags = __gmpfr_flags;
++      inex_ref = inex_sin || inex_cos;
++      flags_ref = flags_sin | flags_cos;
++      if (!(mpfr_equal_p (s1, s2) && mpfr_equal_p (c1, c2)) ||
++          inex != inex_ref || flags != flags_ref)
+         {
+-          printf ("mpfr_sin_cos and mpfr_sin/mpfr_cos disagree on %s,\nx = ",
+-                  mpfr_print_rnd_mode (rnd));
++          printf ("mpfr_sin_cos and mpfr_sin/mpfr_cos disagree on %s,"
++                  " i = %d\nx = ", mpfr_print_rnd_mode (rnd), i);
+           mpfr_dump (x);
+           printf ("s1 = ");
+           mpfr_dump (s1);
+@@ -408,9 +441,16 @@
+           mpfr_dump (c1);
+           printf ("c2 = ");
+           mpfr_dump (c2);
++          printf ("inex_sin = %d, inex_cos = %d, inex = %d (expected %d)\n",
++                  inex_sin, inex_cos, inex, inex_ref);
++          printf ("flags_sin = 0x%x, flags_cos = 0x%x, "
++                  "flags = 0x%x (expected 0x%x)\n",
++                  flags_sin, flags_cos, flags, flags_ref);
+           exit (1);
+         }
+       mpfr_clears (x, s1, s2, c1, c2, (mpfr_ptr) 0);
++      mpfr_set_emin (emin);
++      mpfr_set_emax (emax);
+     }
+ }
+ 
+diff -ur mpfr-2.4.2.orig/version.c mpfr-2.4.2/version.c
+--- mpfr-2.4.2.orig/version.c	2010-03-08 22:28:46.000000000 +0100
++++ mpfr-2.4.2/version.c	2010-03-08 22:28:53.000000000 +0100
+@@ -25,5 +25,5 @@
+ const char *
+ mpfr_get_version (void)
+ {
+-  return "2.4.2";
++  return "2.4.2-p3";
+ }




More information about the coreboot mailing list